const fs = require('fs');
const express = require('express');
const app = express();
const app_serve = express();
const mysql = require('mysql2')
const SendSeekable = require('send-seekable');

const pool = mysql.createPool({
    keepAliveInitialDelay: 10000, enableKeepAlive: true,
})
const db = mysql.createConnection({
    host: 'mc.andyxie.cn', user: 'instrunet', password: 'Moyingren2015', database: "instrunet_data", pool: pool,
})
const nodemailer = require('nodemailer')

const bodyParser = require("body-parser");
const nrc = require('node-run-cmd')
const https = require("node:https");

app.use(bodyParser.json({"limit": "200mb"}));
app.use(express.json());

app_serve.use(bodyParser.json({"limit": "200mb"}));
app_serve.use(express.json());
app_serve.use(SendSeekable)

const transporter = nodemailer.createTransport({
    host: 'smtp.qq.com',
    port: 465,
    secure: true,
    auth: {
        user: '3095864740@qq.com',
        pass: 'caemyuagapsadfff',
    }
})

app.post('/submit', function (req, res) {
    let uuid = crypto.randomUUID()
    db.connect(function (err) {
        if (err) {
            console.log(err)
        }
    })

    res.header("Access-Control-Allow-Origin", "*");


    try {
        fetch(req.body.file).then(res => {
            res.arrayBuffer().then(r => fs.writeFileSync("./" + uuid, Buffer.from(r)));
        })

        res.end("api_success");
    } catch (err) {
        res.status(500).send("Server Error");
        return
    }

    const callback = function (d) {
        console.log(d.toString());
    }
    const errcb = function (d) {
        console.log(d.toString());
    }
    let kind_of = [];

    switch (req.body.kind) {
        case 0:
            kind_of[0] = `audio-separator ./${uuid} --model_filename UVR-MDX-NET-Inst_HQ_5.onnx  --mdx_segment_size 4000 --mdx_overlap 0.75  --output_format mp3 --mdx_batch_size 300 --output_dir output`
            kind_of[1] = `./output/${uuid}_(Instrumental)_UVR-MDX-NET-Inst_HQ_5.mp3`
            kind_of[2] = `${uuid}_(Instrumental)_UVR-MDX-NET-Inst_HQ_5.mp3`
            kind_of[3] = `./output/${uuid}_(Vocals)_UVR-MDX-NET-Inst_HQ_5.mp3`
            break;
        case 1:
            kind_of[0] = `audio-separator ./${uuid} --model_filename UVR_MDXNET_KARA.onnx  --mdx_segment_size 4000 --mdx_overlap 0.75 --output_format mp3 --mdx_batch_size 300 --output_dir output`
            kind_of[1] = `./output/${uuid}_(Instrumental)_UVR_MDXNET_KARA.mp3`
            kind_of[2] = `${uuid}_(Instrumental)_UVR_MDXNET_KARA.mp3`
            kind_of[3] = `./output/${uuid}_(Vocals)_UVR_MDXNET_KARA.mp3`
            break;

    }
    nrc.run([kind_of[0]], {
        onData: callback, onError: errcb
    }).then(() => {

        db.execute(("INSERT INTO instrunet_entry (uuid, song_name, album_name, link_to, databinary, artist,kind) VALUES (?,?,?,?,?,?,?)"), [uuid, req.body.name, req.body.albumName, req.body.link, fs.readFileSync(kind_of[1]), req.body.artist, req.body.kind])
        db.unprepare(() => {

        })
        fs.rm(kind_of[1], (err) => {
            if (err) {
                console.log(err);

            }
        })
        fs.rm(uuid, (err) => {
            if (err) {
                console.log(err);

            }


        })
        if (req.body.email !== undefined) {
            console.log(req.body.email)
            transporter.sendMail({
                from: '"xiey0" <xiey0@qq.com>',
                to: req.body.email,
                subject: "你的音频已处理完成。",
                text: "你的音频已处理完成。",
                html:
                    "<h1>哈喽👋</h1><p>你在伴奏网网站上传的音频已经处理完毕，快来下载吧！<br/>下载链接：<br/><a href='https://andyxie.cn:8201/" + uuid + "'>这里</a><br/><br/>" +
                    "与其他网站不一样，本邮件发送邮箱真的有个伞兵在后面！<br/>" +
                    "请随意骚扰！</p>"
            }).then((result) => {
                console.log("Message sent: %s", result.messageId)

            })
        }


    })


})

app.options('/submit', function (req, res) {
    res.header("Access-Control-Allow-Origin", "*");
    res.header("Access-Control-Allow-Headers", "Content-Type");
    res.end()
})


app.post('/search_api', function (req, res) {
    function OnFetched(err, rows) {
        try {
            res.header("Access-Control-Allow-Origin", "*");
            res.end(JSON.stringify(rows));
        } catch (e) {

        }

    }

    db.execute(`SELECT uuid, song_name, album_name, artist, kind
                FROM instrunet_entry
                WHERE song_name like '%${req.body.searchStr}%'
                   or album_name like '%${req.body.searchStr}%'
                   or artist like '%${req.body.searchStr}%'`, OnFetched)
    db.unprepare()
})

app.options('/search_api', function (req, res) {
    res.header("Access-Control-Allow-Origin", "*");
    res.header("Access-Control-Allow-Headers", "Content-Type");
    res.end()
})
app.get("/getSingle", function (req, res) {
    if (req.query.id) {
        db.execute(`SELECT song_name, album_name, artist
                    FROM instrunet_entry
                    WHERE uuid = "${req.query.id}"`, function (err, rows) {
            if (err) {
                console.log(err);

            }
            res.contentType("application/json");
            res.header("Access-Control-Allow-Origin", "*");
            res.header("Access-Control-Allow-Headers", "Content-Type");
            res.end(JSON.stringify(rows[0]));
        })

    }else{
        res.contentType("application/json");
        res.header("Access-Control-Allow-Origin", "*");
        res.header("Access-Control-Allow-Headers", "Content-Type");
        res.end("{}")

    }
})
app_serve.get('/:uuid', function (req, res, next) {
    async function Provider(err, rows) {
        try {
            res.header("Access-Control-Allow-Origin", "*");
            /** @type {ArrayBuffer}*/
            let buffer = rows[0].databinary
            res.sendSeekable(buffer)
            db.unprepare()


        } catch (e) {
            console.log(e)
            console.log("Triggered err");

        }
    }

    db.execute(`SELECT databinary
                FROM instrunet_entry
                WHERE uuid = '${req.params.uuid}'`, Provider)
    db.unprepare()
})

//
// https.createServer({
//     key: fs.readFileSync('andyxie.cn.key'), cert: fs.readFileSync('andyxie.cn.pem')
// }, app).listen(8080)

app.listen(8080)
app_serve.listen(8079)

// https.createServer({
//     key: fs.readFileSync('andyxie.cn.key'), cert: fs.readFileSync('andyxie.cn.pem')
//
// }, app_serve).listen(8079)